// XDVView.cpp : implementation file
//

#include "stdafx.h"
#include "DVTestDlg.h"
#include "XDVView.h"

BYTE *buf;
// XDVView

IMPLEMENT_DYNCREATE(XDVView, CScrollView)

XDVView::XDVView()
{
	Pbmp = (LPBITMAPINFO)new BYTE[sizeof(BITMAPINFOHEADER) + 
		256 * sizeof(RGBQUAD)];

	int size;
	//BYTE *buf; // pointer to character
	std::ifstream file (".\\image2.raw", std::ios::in|std::ios::binary|std::ios::ate);
	if (file.is_open())
	{
	file.seekg (0, std::ios::end);
	size = file.tellg(); 
	buf = new BYTE [size]; 
	file.seekg (0, std::ios::beg); 
	file.read ((char*)buf, size); 
	file.close();
	}
}

XDVView::~XDVView()
{
	delete [] buf;
}


BEGIN_MESSAGE_MAP(XDVView, CScrollView)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// XDVView drawing

void XDVView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 768;
	sizeTotal.cy = 756;
	SetScrollSizes(MM_TEXT, sizeTotal);
}



void XDVView::OnDraw(CDC* dc)
{
	CDocument* pDoc = GetDocument();

	int ht;
	int wh;
	ht = Pbmp->bmiHeader.biHeight;
	wh = Pbmp->bmiHeader.biWidth;

	HDC hdc=::GetDC(m_hWnd);

	SetDIBitsToDevice(hdc,0,0,(DWORD)wh,(DWORD)ht,0,0,0,
	(WORD)ht,buf,Pbmp,DIB_RGB_COLORS);

}


// XDVView diagnostics

#ifdef _DEBUG
void XDVView::AssertValid() const
{
	CScrollView::AssertValid();
}

#ifndef _WIN32_WCE
void XDVView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif
#endif //_DEBUG

void XDVView::InitInfoBMP()
{
	Pbmp->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Pbmp->bmiHeader.biWidth = 768; //
	Pbmp->bmiHeader.biHeight = 756;
	Pbmp->bmiHeader.biPlanes = 1; 
	Pbmp->bmiHeader.biBitCount = 8;
	Pbmp->bmiHeader.biCompression = 0;
	Pbmp->bmiHeader.biSizeImage = 0; 
	Pbmp->bmiHeader.biXPelsPerMeter = 0;
	Pbmp->bmiHeader.biYPelsPerMeter = 0;
	Pbmp->bmiHeader.biClrUsed = 0; 
	Pbmp->bmiHeader.biClrImportant = 0;
     

	for( int i=0; i < 256; i++)
	{
	   Pbmp->bmiColors[i].rgbRed = i;
	   Pbmp->bmiColors[i].rgbGreen = i;
	   Pbmp->bmiColors[i].rgbBlue = i;
	   Pbmp->bmiColors[i].rgbReserved = 0;
	}
}

// XDVView message handlers
void XDVView::OnSize(UINT nType, int cx, int cy)
{
	CScrollView::OnSize(nType, cx, cy);

	InitInfoBMP();
}

void XDVView::update()
{
	OnInitialUpdate();
}